# gui.py
# Einbau von Demobeispiel_bearbeitet.py
## Anpassen der Benennungen, weiteres Menue
import wx

##from badewanne import Badewanne
##from bett import Bett
##from dusche import Dusche
##from herd import Herd
##from klosett import Klosett
##from sessel import Sessel
##from schrank import Schrank
##from sofa import Sofa
##from stuhl import Stuhl
##from tisch import Tisch

from raumplanerModell import RaumplanerModell

### ---------------------------------------------------
class Gui(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=wx.DefaultPosition,
            size=wx.DefaultSize, style=wx.DEFAULT_FRAME_STYLE
            ):
        
        self.modell=RaumplanerModell.GibModell() # Ergaenzung
        
        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        panel = wx.Panel(self, -1)
        

        ### Menu-Abschnitt
        # Prepare the menu bar
        menuBar = wx.MenuBar()

        # erstes Menue
        dateiMenu = wx.Menu()
        dateiMenu.Append(101, "Oeffnen")
        dateiMenu.Append(102, "Speichern")
        dateiMenu.Append(103, "Bild-Export")
        dateiMenu.AppendSeparator()
        dateiMenu.Append(104, "Beenden")
        # Add menu to the menu bar
        menuBar.Append(dateiMenu, "Datei")

        # zweites Menue
        neuMenu = wx.Menu()
        neuMenu.Append(201, "Stuhl")
        neuMenu.Append(202, "Tisch")
        neuMenu.Append(203, "Schrank")
        neuMenu.Append(204, "Sessel")
        neuMenu.Append(205, "Sofa")
        neuMenu.Append(207, "Ovaler Tisch")
        neuMenu.Append(206, "Bett")
        neuMenu.AppendSeparator()
        neuMenu.Append(210, "Badewanne")
        neuMenu.Append(211, "Dusche")
        neuMenu.Append(212, "Klosett")
        neuMenu.Append(213, "Herd")
        # Add menu to the menu bar
        menuBar.Append(neuMenu, "&Moebel")
        
        self.SetMenuBar(menuBar)

        ### Menu events
        self.Bind(wx.EVT_MENU, self.OnOeffnen, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnBildExport, id=103)
        self.Bind(wx.EVT_MENU, self.OnBeenden, id=104) ## Korrektur

        self.Bind(wx.EVT_MENU, self.OnStuhl, id=201)
        self.Bind(wx.EVT_MENU, self.OnTisch, id=202)
        self.Bind(wx.EVT_MENU, self.OnSchrank, id=203)
        self.Bind(wx.EVT_MENU, self.OnSessel, id=204)
        self.Bind(wx.EVT_MENU, self.OnSofa, id=205)
        self.Bind(wx.EVT_MENU, self.OnOvalerTisch, id=207)
        self.Bind(wx.EVT_MENU, self.OnBett, id=206)
        self.Bind(wx.EVT_MENU, self.OnBadewanne, id=210)
        self.Bind(wx.EVT_MENU, self.OnDusche, id=211)
        self.Bind(wx.EVT_MENU, self.OnKlosett, id=212)
        self.Bind(wx.EVT_MENU, self.OnHerd, id=213)

        ### Button-Abschnitt
        button = wx.Button(panel, 1003, "Beenden")
        button.SetPosition((215, 15))
        self.Bind(wx.EVT_BUTTON, self.OnBeenden, button)
        ### Fensterereignis
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

    ### Ereignisbehandlung ###
    ### Menu-Abschnitt
    def OnOeffnen(self, event):
        self.modell.Lade("Daten/daten.dat")

    def OnSpeichern(self, event):
        self.modell.Speichere("Daten/daten.dat")

    def OnBildExport(self, event):
        self.modell.BildExport("Bilder/Bild.png")

    def OnStuhl(self, event):
        self.modell.Neu("Stuhl",10, 30, 40, 40, 270, 'blue', True)

    def OnTisch(self, event):
        self.modell.Neu("Tisch",60, 20, 120, 60, 0, 'red', True)

    def OnSchrank(self, event):
        self.modell.Neu("Schrank",280, 40, 100, 60, 90, 'brown', True)

    def OnSessel(self, event):
        self.modell.Neu("Sessel", 100, 130, 60, 60, 0, 'orange', True)

    def OnSofa(self, event):
        self.modell.Neu("Sofa", 70, 290, 120, 60, 180, 'orange', True)

    def OnOvalerTisch(self, event):
        self.modell.Neu("OvalerTisch", 70, 200, 120, 80, 0, 'brown', True)

    def OnBett(self, event):
        self.modell.Neu("Bett", 380, 20, sichtbar=True)

    def OnBadewanne(self, event):
        self.modell.Neu("Badewanne", 20, 440, sichtbar=True)

    def OnDusche(self, event):
        self.modell.Neu("Dusche", 300, 440, sichtbar=True)

    def OnKlosett(self, event):
        self.modell.Neu("Klosett", 500, 440, sichtbar=True)

    def OnHerd(self, event):
        self.modell.Neu("Herd", 500, 300, sichtbar=True)


    ### Button-Abschnitt
    def OnBeenden(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Anwendung fuer Raumplaner"""
    def OnInit(self):
        self.fenster = Gui(None, 1000, "Raumplaner")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    app.MainLoop()
